"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var pie_chart_1 = __importDefault(require("react-icons/lib/fa/pie-chart"));
var Button_1 = __importDefault(require("../Button"));
var Grid_1 = require("../Grid");
var Input_1 = __importDefault(require("../Input"));
var Modal_1 = __importDefault(require("../Modal"));
var Select_1 = __importDefault(require("../Select"));
var Txt_1 = __importDefault(require("../Txt"));
var FilterDescription_1 = __importDefault(require("./FilterDescription"));
var FilterSummary = (function (_super) {
    __extends(FilterSummary, _super);
    function FilterSummary(props) {
        var _this = _super.call(this, props) || this;
        _this.save = function (event) {
            if (event) {
                event.preventDefault();
            }
            var _a = _this.state, name = _a.name, scope = _a.scope;
            if (!name) {
                return;
            }
            _this.props.saveView(name, scope);
            _this.setState({
                name: '',
                showForm: false,
                id: '',
            });
        };
        _this.state = {
            name: '',
            showForm: false,
            id: '',
            scope: _this.props.scopes ? _this.props.scopes[0].slug : null,
        };
        return _this;
    }
    FilterSummary.prototype.handleChange = function (e) {
        var name = e.target.value;
        this.setState({ name: name });
    };
    FilterSummary.prototype.render = function () {
        var _this = this;
        var scopes = this.props.scopes;
        return (React.createElement(Grid_1.Box, { p: 3, mt: 3, width: "100%", bg: "quartenary.light" },
            this.state.showForm && (React.createElement(Modal_1.default, { title: "Save current view", cancel: function () { return _this.setState({ showForm: false }); }, done: this.save, action: "Save" },
                React.createElement("form", { onSubmit: this.save },
                    !!scopes && scopes.length > 1 && (React.createElement(Grid_1.Flex, { mb: 4, alignItems: "center" },
                        React.createElement(Txt_1.default, { width: 90 }, "Visible to:"),
                        React.createElement(Select_1.default, { ml: 2, width: "auto", options: scopes, valueKey: "slug", labelKey: "name", value: scopes.find(function (x) { return x.slug === _this.state.scope; }), onChange: function (_a) {
                                var option = _a.option;
                                return _this.setState({
                                    scope: option.slug,
                                });
                            } }))),
                    React.createElement(Input_1.default, { width: "100%", value: this.state.name, placeholder: "Enter a name for the view", onChange: function (e) {
                            return _this.handleChange(e);
                        }, autoFocus: true })))),
            React.createElement(Grid_1.Flex, { mb: 2, justifyContent: "space-between" },
                React.createElement(Grid_1.Flex, null,
                    React.createElement(Txt_1.default, { mr: 2 },
                        React.createElement(Txt_1.default.span, { bold: true }, "Filters"),
                        " (",
                        this.props.filters.length,
                        ")"),
                    React.createElement(Button_1.default, { plain: true, primary: true, onClick: this.props.clearAllFilters }, "Clear all")),
                React.createElement(Button_1.default, { primary: true, plain: true, onClick: function () { return _this.setState({ showForm: !_this.state.showForm }); }, icon: React.createElement(pie_chart_1.default, null) }, "Save as view")),
            React.createElement(Grid_1.Flex, { flexWrap: "wrap" }, this.props.filters.map(function (filter, index) {
                return (React.createElement(FilterDescription_1.default, { key: filter.$id || index, filter: filter, onClick: function () { return _this.props.edit(filter); }, onClose: function () { return _this.props.delete(filter); } }));
            }))));
    };
    return FilterSummary;
}(React.Component));
exports.default = FilterSummary;
