"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var __1 = require("../../../../");
var BaseInput = function (props) {
    var value = props.value, readonly = props.readonly, disabled = props.disabled, autofocus = props.autofocus, onBlur = props.onBlur, onFocus = props.onFocus, options = props.options, schema = props.schema, formContext = props.formContext, inputProps = __rest(props, ["value", "readonly", "disabled", "autofocus", "onBlur", "onFocus", "options", "schema", "formContext"]);
    if (schema.type === 'number') {
        inputProps.type = 'number';
    }
    else {
        inputProps.type = options.inputType || inputProps.type || 'text';
    }
    var change = function (_a) {
        var value = _a.target.value;
        return props.onChange(value === '' ? options.emptyValue : value);
    };
    return (React.createElement(__1.Input, __assign({ width: "100%", readOnly: readonly, disabled: disabled, autoFocus: autofocus, value: value == null ? '' : value }, inputProps, { onChange: change, onBlur: onBlur && (function (event) { return onBlur(inputProps.id, event.target.value); }), onFocus: onFocus && (function (event) { return onFocus(inputProps.id, event.target.value); }) })));
};
exports.default = BaseInput;
